<template>
    <div style="width: 100%;">
        <!-- SNACKBAR -->
        <v-snackbar
            v-model="snackbar"
            :timeout="5000"
            :multi-line="false"
            :vertical="false"
            :top="true"
            >
            {{ msgSnackbar }}
            <v-btn flat @click="updateAlertSuccess(false)"> Tutup </v-btn>
        </v-snackbar>

        <!-- ERROR DIALOG -->
        <v-dialog v-model="dialog_error" max-width="500px">
            <v-card>
                <v-card-title>
                    <span>ERROR !</span>
                    <v-spacer></v-spacer>
                </v-card-title>
                <v-divider></v-divider>
                    <div class="ma-3 red--text">{{ msgError }}</div>
                    <v-divider></v-divider>
                <v-card-actions>
                    <v-spacer></v-spacer>
                    <v-btn color="primary" flat @click="dialog_error = false"
                        >Tutup</v-btn
                    >
                </v-card-actions>
            </v-card>
        </v-dialog>
        <!-- END ERROR DIALOG -->

        <!-- FORM KANAN -->
        <v-layout row wrap>
            <v-flex xs12 fill-height>
                <v-toolbar color="primary" dark>
                <v-toolbar-title class="white--text"
                    >SUPPLIER ITEM PRICE</v-toolbar-title
                >
                <v-spacer></v-spacer>
                <v-btn :disabled=" Object.keys(this.$store.state.supplier.selected_supplier).length === 0" icon @click="openDialogDetail()">
                    <v-icon>add_box</v-icon>
                </v-btn>
                </v-toolbar>
                <v-card class="pa-2">
                        <v-layout>
                            <v-flex xs3 pl-2>
                                <v-text-field
                                    label="Cari..."
                                    placeholder="Item"
                                    outline
                                    v-model="xsearch_detail"
                                    hide-details
                                ></v-text-field>
                            </v-flex>
                            <v-flex pl-2 pr-2>
                                <v-btn
                                    dark
                                    color="primary"
                                    style="min-width: 50px; height: 50px; margin: 0"
                                    @click="detailTableSearch()"
                                    >
                                    <v-icon>search</v-icon>
                                </v-btn>
                            </v-flex>
                        </v-layout>
                </v-card>
                <v-card class="pa-2 mt-2">
                    <v-layout row style="max-height: 600px; overflow: auto">
                        <v-flex xs12 pl-2 pr-2 pt-2 pb-2>
                            <v-data-table
                                :items="supplier_prices"
                                :headers="headers"
                                :loading="isLoading"
                                hide-actions
                                class="elevation-1"
                            >
                                <template slot="items" slot-scope="props">
                                    <td
                                        class="text-xs-left pa-2"
                                        v-bind:class="{ 'amber lighten-4': isSelected(props.item) }"
                                        @click="selectMe(props.item)"
                                    >{{ props.item.M_ItemCode }}</td>
                                    <td
                                        class="text-xs-left pa-2"
                                        v-bind:class="{ 'amber lighten-4': isSelected(props.item) }"
                                        @click="selectMe(props.item)"
                                    >{{ props.item.M_ItemDesc }}</td>
                                    <td
                                        class="text-xs-left pa-2"
                                        v-bind:class="{ 'amber lighten-4': isSelected(props.item) }"
                                        @click="selectMe(props.item)"
                                    >{{ props.item.ItemUnitName }}</td>
                                    <td
                                        class="text-xs-left pa-2"
                                        v-bind:class="{ 'amber lighten-4': isSelected(props.item) }"
                                        @click="selectMe(props.item)"
                                    >
                                        Rp {{
	                                        oneMoney(props.item.SupplierPricePrice)
                                        }}
                                    </td>
                                    <td class="text-xs-center pa-2"
                                        v-bind:class="{ 'amber lighten-4': isSelected(props.item) }"
                                        @click="selectMe(props.item)"
                                    >
                                        <v-icon small @click="openUpdateDetail(props.item)"
                                        >edit</v-icon
                                        >
                                        <v-icon small @click="deleteDetail(props.item)"
                                        >delete</v-icon
                                        >
                                    </td>
                                </template>
                            </v-data-table>
                        </v-flex>
                    </v-layout>
                    <v-divider></v-divider>
                    <v-pagination
                        style="margin-top: 10px; margin-bottom: 10px"
                        v-model="curr_page" :length="xtotal_page"
                    ></v-pagination>
                </v-card>
            </v-flex>
        </v-layout>

        <!-- POP UP FORM ADD SUPPLIER ITEM -->
        <template>
            <v-layout row justify-center>
                <v-dialog v-model="dialogFormDetail" persistent max-width="40vw">
                    <v-card>
                        <v-card-title class="headline grey lighten-2" primary-title>
                        FORM SUPPLIER ITEM PRICE
                        </v-card-title>
                        <v-card-text class="pt-2 pb-0">
                            <v-layout wrap>
                                <v-flex xs12 pa-2>
                                    <v-autocomplete label="Item*" :items="itemList" v-model="selectedItem"
                                        :search-input.sync="search_item"
                                        auto-select-first no-filter 
                                        item-text="M_ItemDesc"
                                        return-object
                                        hide-details
                                        no-data-text="Pilih Item">
                                        <template slot="item" slot-scope="{ item }">
                                            <v-list-tile-content>
                                                <v-list-tile-title>
                                                    {{ item.M_ItemDesc }} ({{ item.M_ItemCode }})
                                                </v-list-tile-title>
                                                <v-list-tile-sub-title v-text="item.M_ItemCode"></v-list-tile-sub-title>
                                            </v-list-tile-content>
                                        </template>
                                    </v-autocomplete>
                                    <p v-if="checkErrorFormDetail('requireItem')" class="error pl-2 pr-2" style="color:#fff">Item belum dipilih</p>
                                </v-flex>
                                <v-flex xs12 pa-2>
                                    <v-autocomplete label="Item Unit" v-model="selected_unit"
                                        :items="item_units" :search-input.sync="search_unit"
                                        auto-select-first no-filter item-text="ItemUnitName"
                                        return-object hide-details
                                        no-data-text="Pilih Item Unit"
                                        >
                                        <template slot="item" slot-scope="{ item }">
                                            <v-list-tile-content>
                                                <v-list-tile-title v-text="item.ItemUnitName"></v-list-tile-title>
                                            </v-list-tile-content>
                                        </template>
                                    </v-autocomplete> 
                                    <p v-if="checkErrorFormDetail('requireUnit')" class="error pl-2 pr-2" style="color:#fff">Unit belum dipilih</p>
                                </v-flex>
                                <v-flex xs12 pa-2>
                                    <!-- <v-text-field
                                        label="Harga"
                                        type="number"
                                        prefix="Rp"
                                        v-model="xPrice"
                                        @focus="clearPrice"
                                        @blur="resetPrice"
                                        :hint="convertMoney(xPrice)"
                                    ></v-text-field> -->
                                    <v-text-field 
                                        prefix="Rp"
                                        v-model="formattedPrice"
                                        @focus="clearPrice"
                                        @blur="resetPrice"
                                        label="Harga Per Item">
                                    </v-text-field>
                                    <p v-if="checkErrorFormDetail('requirePrice')" class="error pl-2 pr-2" style="color:#fff">Harga belum diisi</p>
                                </v-flex>
                                <v-flex xs12 pa-2>
                                    <v-select v-model="selected_type" :items="types" item-text="name" label="Tipe"
                                        return-object></v-select>
                                </v-flex>
                                <v-flex xs12 pa-2>
                                    <v-card v-if="selected_type.value == 'R'" class="pa-2">
                                        <v-layout row>
                                        <v-flex pa-2 xs6>
                                            <v-text-field label="Qty Min" v-model="min_value" hide-details outline></v-text-field>
                                            <v-switch v-model="min_inclusive" label="Inclusive"></v-switch>
                                        </v-flex>
                                        <v-flex pa-2 xs6>
                                            <v-text-field label="Qty Max" v-model="max_value" hide-details outline></v-text-field>
                                            <v-switch v-model="max_inclusive" label="Inclusive"></v-switch>
                                        </v-flex>
                                        </v-layout>
                                    </v-card>
                                </v-flex>
                            </v-layout>
                        </v-card-text>
                        <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="error" flat @click="closeDialogForm()">
                            Tutup
                        </v-btn>
                        <v-btn v-if="xactdetail === 'new'" color="primary" @click="saveFormDetail()">Simpan</v-btn>
                        <v-btn v-if="xactdetail === 'edit'" color="primary"  @click="updateFormDetail()">Simpan Perubahan</v-btn>
                        </v-card-actions>
                    </v-card>
                </v-dialog>
            </v-layout>
        </template>
        <!-- end form -->

        <template>
            <v-dialog v-model="dialogdeletealert" max-width="30%">
                <v-card>
                    <v-card-title class="headline grey lighten-2 pt-2 pb-2" primary-title>
                        Peringatan !
                    </v-card-title>
                    <v-card-text class="pt-2 pb-2">
                        <v-layout row>
                            <v-flex xs12 d-flex>
                                <v-layout row>
                                    <v-flex pb-1 xs12>
                                        <v-layout row>
                                            <v-flex pt-2 pr-2 xs12>
                                                Yakin, mau hapus Item price: <span class="font-weight-bold">{{ msgalertname }}</span> ?
                                            </v-flex>
                                        </v-layout>
                                    </v-flex>
                                </v-layout>
                            </v-flex>
                        </v-layout>
                    </v-card-text>
                    <v-divider></v-divider>
                    <v-card-actions>
                        <v-spacer></v-spacer>
                        <v-btn color="error" flat @click="dialogdeletealert = false">
                            Tutup
                        </v-btn>
                        <v-btn color="primary" @click="closeDeleteAlert()">
                            Yakin lah
                        </v-btn>
                    </v-card-actions>
                </v-card>
            </v-dialog>
        </template>
    </div>
</template>

<style scoped>
.date-type-table {
  display: flex;
  flex-direction: column;
  gap: 0.5rem;
}

.table.v-table tbody td,
table.v-table tbody th {
  height: 40px;
}

.table.v-table thead tr {
  height: 40px;
}

.scroll-container {
  scroll-padding: 50px 0 0 50px;
}
</style>

<script>
module.exports = {
    components: {

    },
    data() {
        return {
            xPrice: 0,
            search_item: "",
            search_unit: "",
            xid: 0,
            dialogdeletealert: false,
            msgalertname: "",
            types: [
                {id:"1", name:"Tak Terhingga", value:"T"},
                {id:"2", name:"Rentang", value:"R"}
            ],
            headers: [
                {
                    text: "KODE ITEM",
                    align: "left",
                    sortable: false,
                    value: "no",
                    width: "10%",
                    class: "blue lighten-3 white--text",
                },
                {
                    text: "ITEM",
                    align: "left",
                    sortable: false,
                    value: "no",
                    width: "35%",
                    class: "blue lighten-3 white--text",
                },
                {
                    text: "UNIT",
                    align: "left",
                    sortable: false,
                    value: "request",
                    width: "30%",
                    class: "blue lighten-3 white--text",
                },
                {
                    text: "HARGA",
                    align: "left",
                    sortable: false,
                    value: "total",
                    width: "15%",
                    class: "blue lighten-3 white--text",
                },
                {
                    text: "AKSI",
                    align: "left",
                    sortable: false,
                    value: "act",
                    width: "10%",
                    class: "blue lighten-3 white--text",
                },
            ],
        }
    },
    mounted() {
        this.$store.dispatch("supplier/searchItem", this.search_item)
    },
    computed: {
        formattedPrice: {
            get() {
                return this.oneMoney(this.xPrice);
            },
            set(value) {
                // Hilangkan titik dan koma, ubah jadi number
                let raw = value.replace(/\./g, '').replace(',', '.');
                this.xPrice = parseFloat(raw) || 0;
            }
        },
        supplier_prices() {
            return this.$store.state.supplier.supplier_prices
        },
        isLoading() {
            return this.$store.state.supplier.search_status_detail == 1
        },
        xsearch_detail: {
            get() {
                return this.$store.state.supplier.xsearch_detail
            },
            set(val) {
                this.$store.commit("supplier/update_xsearch_detail", val)
            }
        },
        curr_page: {
            get() {
                return this.$store.state.supplier.current_page_detail
            },
            set(val) {
                this.$store.commit("supplier/update_current_page_detail", val)
                this.$store.dispatch("supplier/searchdetail")
            }
        },
        xtotal_page: {
            get() {
                return this.$store.state.supplier.total_page_supplier_price
            },
            set(val) {
                this.$store.commit("supplier/update_total_page_supplier_price", val)
            }
        },
        dialogFormDetail: {
            get() {
                return this.$store.state.supplier.dialog_form_detail
            },
            set(val) {
                this.$store.commit("supplier/update_dialog_form_detail", val)
            }
        },
        xactdetail: {
            get() {
                return this.$store.state.supplier.act_detail
            },
            set(val) {
                this.$store.commit("supplier/update_act_detail", val)
            }
        },
        itemList() {
            return this.$store.state.supplier.itemList.map(item => ({
                ...item,
                itemCodeDesc: `${item.M_ItemDesc} (${item.M_ItemCode})`
            }));
        },
        selectedItem: {
            get() {
                return this.$store.state.supplier.selected_item;
            },
            set(val) {
                this.$store.commit("supplier/update_selected_item", val);
                this.$store.dispatch("supplier/getUnit", {search: this.search_unit, itemID: this.selectedItem.M_ItemID})
            },
        },
        item_units() {
            return this.$store.state.supplier.itemUnits;
        },
        selected_unit: {
            get() {
                return this.$store.state.supplier.selected_unit;
            },
            set(val) {
                this.$store.commit("supplier/update_selected_unit", val);
            },
        },
        snackbar: {
            get() {
                return this.$store.state.supplier.alert_success_detail
            },
            set(val) {
                this.$store.commit("supplier/update_alert_success_detail", val)
            }
        },
        msgSnackbar() {
            return this.$store.state.supplier.msg_success;
        },
        dialog_error: {
            get() {
                return this.$store.state.supplier.alert_error_detail
            },
            set(val) {
                this.$store.commit("supplier/update_alert_error_detail", val)
            },
        },
        msgError() {
            return this.$store.state.supplier.save_error_message
        },
        selected_type: {
            get() {
                return this.$store.state.supplier.selected_type
            },
            set(val) {
                this.$store.commit("supplier/update_selected_type", val)
                if (this.xactdetail == 'new') {
                    this.max_inclusive = false
                    this.min_inclusive = false
                    this.max_value = 0
                    this.min_value = 0
                }
            },
        },
        max_inclusive: {
            get() {
                return this.$store.state.supplier.max_inclusive;
            },
            set(val) {
                this.$store.commit("supplier/update_max_inclusive", val);
            },
        },
        min_inclusive: {
            get() {
                return this.$store.state.supplier.min_inclusive;
            },
            set(val) {
                this.$store.commit("supplier/update_min_inclusive", val);
            },
        },
        max_value: {
            get() {
                return this.$store.state.supplier.max_value;
            },
            set(val) {
                this.$store.commit("supplier/update_max_value", val);
            },
        },
        min_value: {
            get() {
                return this.$store.state.supplier.min_value;
            },
            set(val) {
                this.$store.commit("supplier/update_min_value", val);
            },
        },
    },
    methods: {
        roundToThreeSignificantDigits(num) {
            if (num === 0) return 0;
            
            // Hitung jumlah digit
            const absNum = Math.abs(num);
            const magnitude = Math.floor(Math.log10(absNum)) + 1;
            
            // Jika kurang dari 3 digit, tidak perlu dibulatkan
            if (magnitude <= 3) return num;
            
            // Hitung faktor pembulatan
            const factor = Math.pow(10, magnitude - 3);
            
            // Bulatkan
            return Math.round(num / factor) * factor;
        },
        oneMoney(value){
            //return one_money(value);
            let splitValue = value.toString().split(".");
            if(splitValue.length > 1) {
                let val = splitValue[0]
                return val.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".") + "," + this.roundToThreeSignificantDigits(splitValue[1]);
            } else {
                return value.toString().replace(/\B(?=(\d{3})+(?!\d))/g, ".");
            }
        },
        convertMoney(money){
            return one_money(money)
        },
        formatAngka(nilai) {
            // Jika tidak ada nilai
            if (!nilai) return '';
            
            try {
                // Ubah ke string
                let strNilai = String(nilai);
                
                // Jika berisi titik desimal
                if (strNilai.includes('.')) {
                    // Split bagian utama dan desimal
                    let bagian = strNilai.split('.');
                    let utama = bagian[0];
                    let desimal = bagian[1];
                    
                    // Format bagian utama
                    utama = utama.replace(/\B(?=(\d{3})+(?!\d))/g, '.');
                    
                    // Kembalikan gabungan
                    return utama + ',' + desimal;
                } else {
                    // Tidak ada desimal, hanya format bagian utama
                    return strNilai.replace(/\B(?=(\d{3})+(?!\d))/g, '.');
                }
            } catch (error) {
                console.error("Error formatting:", error);
                return nilai;
            }
        },
        isSelected(p) {
            return p.SupplierPriceID == this.$store.state.supplier.selected_supplier_price.SupplierPriceID
        },
        selectMe(sc) {
            this.$store.commit("supplier/update_selected_supplier_price", sc)
        },
        thr_search: _.debounce(function () {
            this.$store.dispatch("supplier/searchdetail")
        }, 1000),
        thr_search_item: _.debounce(function () {
            this.$store.dispatch("supplier/searchItem", this.search_item)
        }, 1000),
        thr_search_unit: _.debounce(function () {
            this.$store.dispatch("supplier/getUnit", this.search_unit)
        }, 1000),
        detailTableSearch() {
            this.$store.dispatch("supplier/searchdetail")
            this.$store.commit("supplier/update_selected_supplier_price", {})
        },
        openDialogDetail() {
            this.$store.commit("supplier/update_dialog_form_detail", true)
            this.$store.commit("supplier/update_act_detail", "new")
            this.$store.commit("supplier/update_errors", [])
            this.selectedItem = {}
            this.selected_unit = {}
            this.xPrice = 0,
            this.min_value = "";
            this.max_value = "";
            this.min_inclusive = false;
            this.max_inclusive = false;
            this.selected_type = {id:"1", name:"Tak Terhingga", value:"T"}
            this.$store.commit("supplier/update_itemList", [])
            this.$store.commit("supplier/update_itemUnits", [])
        },
        closeDialogForm() {
            this.$store.commit("supplier/update_dialog_form_detail", false)
        },
        clearPrice() {
            if (this.xPrice === 0) {
                this.xPrice = ''
            }
        },
        resetPrice() {
            if (this.xPrice === '' || this.xPrice === null) {
                this.xPrice = 0
            }
        },
        // check error form
        checkErrorFormDetail(value) {
            var errors = this.$store.state.supplier.errors
            if (errors.includes(value)) {
                return true
            } else {
                return false
            }
        },

        saveFormDetail() {
            this.$store.commit("supplier/update_errors", [])
            var errors = this.$store.state.supplier.errors
            
            if(_.isEmpty(this.selectedItem)){
                errors.push("requireItem")
            }
            if(_.isEmpty(this.selected_unit)){
                errors.push("requireUnit")
            }
            if(this.xPrice === '' || this.xPrice === null || this.xPrice === undefined || this.xPrice === 0){
                errors.push("requirePrice")
            }

            if (errors.length === 0) {
                this.$store.commit("supplier/update_errors", [])

                var prm = {
                    supplier_id: this.$store.state.supplier.selected_supplier.SupplierID,
                    item_id: this.selectedItem.M_ItemID,
                    unit_id: this.selected_unit.ItemUnitID,
                    price: this.xPrice,
                    type: this.selected_type.value,
                    min_value: this.min_value,
                    max_value: this.max_value,
                    min_inclusive: this.min_inclusive,
                    max_inclusive: this.max_inclusive
                }

                this.$store.dispatch("supplier/saveprice", prm)  
            }
        },

        openUpdateDetail(val) {
            this.$store.commit("supplier/update_dialog_form_detail", true)
            this.$store.commit("supplier/update_act_detail", "edit")
            this.$store.commit("supplier/update_errors", [])
            this.$store.commit(
                "supplier/update_itemList", [{
                    M_ItemID: val.M_ItemID, 
                    M_ItemDesc: val.M_ItemDesc
                }]
            );
            this.$store.commit(
                "supplier/update_selected_item", {
                    M_ItemID: val.M_ItemID, 
                    M_ItemDesc: val.M_ItemDesc
                }
            );
            this.$store.commit(
                "supplier/update_itemUnits", [{
                    ItemUnitID: val.ItemUnitID,
                    ItemUnitName: val.ItemUnitName
                }]
            );
            this.$store.commit(
                "supplier/update_selected_unit", {
                    ItemUnitID: val.ItemUnitID,
                    ItemUnitName: val.ItemUnitName
                }
            );
            this.min_value = val.SupplierPriceMinQty
            this.min_inclusive = val.SupplierPriceMinInclusive == 'Y' ? true : false
            this.max_value = val.SupplierPriceMaxQty
            this.max_inclusive = val.SupplierPriceMaxInclusive == 'Y' ? true : false
            if (val.SupplierPriceFlagQty == 'R') {
                this.selected_type = {id:"2", name:"Rentang", value:"R"}
            } else {
                this.selected_type = {id:"1", name:"Tak Terhingga", value:"T"}
            }
            this.xPrice = val.SupplierPricePrice
            this.xid = val.SupplierPriceID
        },

        updateFormDetail() {
            this.$store.commit("supplier/update_errors", [])
            var errors = this.$store.state.supplier.errors
            
            if(_.isEmpty(this.selectedItem)){
                errors.push("requireItem")
            }
            if(_.isEmpty(this.selected_unit)){
                errors.push("requireUnit")
            }
            if(this.xPrice === '' || this.xPrice === null || this.xPrice === undefined || this.xPrice === 0){
                errors.push("requirePrice")
            }

            if (errors.length === 0) {
                this.$store.commit("supplier/update_errors", [])

                var prm = {
                    supplier_id: this.$store.state.supplier.selected_supplier.SupplierID,
                    item_id: this.selectedItem.M_ItemID,
                    unit_id: this.selected_unit.ItemUnitID,
                    price: this.xPrice,
                    supplier_price_id: this.xid,
                    type: this.selected_type.value,
                    min_value: this.min_value,
                    max_value: this.max_value,
                    min_inclusive: this.min_inclusive,
                    max_inclusive: this.max_inclusive
                }

                this.$store.dispatch("supplier/updateprice", prm)  
            }
        },

        deleteDetail(val) {
            this.xid = val.SupplierPriceID
            this.msgalertname = val.M_ItemCode + " " + val.M_ItemDesc
            this.dialogdeletealert = true
        },
        closeDeleteAlert() {
            this.dialogdeletealert = false
            this.$store.dispatch("supplier/deleteprice", {
                supplier_price_id: this.xid,
            })
        }
    },
    watch: {
        xsearch_detail(val, old) {
            this.xsearch_detail = val
            this.thr_search()

        },
        search_item(val, old) {
            if (val == old) return;
            if (!val) return;
            if (val.length < 1) return;
            if (this.$store.state.supplier.loading_autocomplete == 1) return;
            this.thr_search_item();
        },
        search_unit(val, old) {
            if (val == old) return;
            if (!val) return;
            if (val.length < 1) return;
            if (this.$store.state.supplier.loading_autocomplete == 1) return;
            this.thr_search_unit();
        },
    }
}
</script>